
-- =================================================================================
--                          TauntMaster2                                          ==
--          http://www.curse.com/addons/wow/taunt-master-2                        ==
--                                                                                ==
-- =================================================================================
-- Author      : Tartarusspawn
-- Create Date : 6/14/2015 9:14:11 PM

local Spacer = "    "
function tm2DrawConfig()


-- =======================================================
-- Interface Gui
-- =======================================================

local panel = CreateFrame("FRAME", "TauntMasterPanel");
	panel.name = GetAddOnMetadata("TauntMaster2", "Title")
	InterfaceOptions_AddCategory(panel);

	panel.Options = CreateFrame("FRAME", "Options",panel);
	panel.Options.name = "Options";
	panel.Options.parent = panel.name
	InterfaceOptions_AddCategory(panel.Options);

	panel.Left = CreateFrame("FRAME", "LeftMouseButton",panel);
	panel.Left.name = Spacer .. "Left Button";
	panel.Left.parent = panel.name
	InterfaceOptions_AddCategory(panel.Left,panel.name);

	panel.Right = CreateFrame("FRAME", "RightMouseButton",panel);
	panel.Right.name = Spacer .. "Right Button";
	panel.Right.parent = panel.name
	InterfaceOptions_AddCategory(panel.Right);

	panel.Middle = CreateFrame("FRAME", "MiddleMouseButton",panel);
	panel.Middle.name = Spacer .. "Middle Button";
	panel.Middle.parent = panel.name
	InterfaceOptions_AddCategory(panel.Middle);

	panel.Button4 = CreateFrame("FRAME", "Button4MouseButton",panel);
	panel.Button4.name = Spacer .. "Button4 Button";
	panel.Button4.parent = panel.name
	InterfaceOptions_AddCategory(panel.Button4);

	panel.Button5 = CreateFrame("FRAME", "Button5MouseButton",panel);
	panel.Button5.name = Spacer .. "Button5 Button";
	panel.Button5.parent = panel.name
	InterfaceOptions_AddCategory(panel.Button5);

local RaidBosses = CreateFrame("FRAME", "RaidBosses",panel);
	RaidBosses.name = GetAddOnMetadata("TauntMaster2", "Title") .. " Raid";
	InterfaceOptions_AddCategory(RaidBosses);

local WorldBosses = CreateFrame("FRAME", "WorldBosses",panel);
	WorldBosses.name = GetAddOnMetadata("TauntMaster2", "Title") .. " World";
	InterfaceOptions_AddCategory(WorldBosses);
	
-- =======================================================
-- Interface 
--
-- panel
-- =======================================================
	
	local Title = panel:CreateFontString (nil, "ARTWORK", "GameFontNormalLarge")
	Title:SetPoint ("TOP", 0, -16)
	Title:SetText (GetAddOnMetadata("TauntMaster2", "Title"))
	panel.Title = "Title"
	
-- =======================================================
-- Interface Options
--
-- panel.Options
-- =======================================================
local GuiOptionLoc = -16

	-- GuildDonationHelper2.panel
	local Title = panel.Options:CreateFontString (nil, "ARTWORK", "GameFontNormalLarge")
	Title:SetPoint ("TOP", 0, GuiOptionLoc)
	Title:SetText (GetAddOnMetadata("TauntMaster2", "Title") .. " Options")
	panel.Options.Title = "Title"

GuiOptionLoc = GuiOptionLoc - 30
local SliderTm2Scale = CreateFrame("Slider", "TM2 Scale" , panel.Options, "OptionsSliderTemplate")
	SliderTm2Scale:ClearAllPoints()
	SliderTm2Scale:SetWidth (500)
	SliderTm2Scale:SetPoint ("TOPLEFT", 8, GuiOptionLoc)
	SliderTm2Scale:SetMinMaxValues(1, 200)
	SliderTm2Scale:SetValueStep(1)
	SliderTm2Scale:SetObeyStepOnDrag(true)
	SliderTm2Scale:SetValue(TauntMaster2.db.char.gui.scale * 100)
		_G["TM2 Scale" .."Low"]:SetText("0");
		_G["TM2 Scale" .."High"]:SetText("200");
		_G["TM2 Scale" .."Text"]:SetText("TM2 Scale" ..":  ".. TauntMaster2.db.char.gui.scale * 100 .. " %");
	SliderTm2Scale:SetScript("OnValueChanged", function(self,tm2scalevalue)
		TauntMaster2.db.char.gui.scale=tm2scalevalue /100
		TauntMasterUnitFrames_Header:SetScale(TauntMaster2.db.char.gui.scale)
		_G["TM2 Scale" .."Text"]:SetText("TM2 Scale" ..":  ".. TauntMaster2.db.char.gui.scale * 100 .. " %" );
	end);
	SliderTm2Scale:Show()


end
























