-- =================================================================================
--                          TauntMaster2                                          ==
--          http://www.curse.com/addons/wow/taunt-master-2                        ==
--                                                                                ==
-- =================================================================================
-- Author      : Tartarusspawn

TauntMaster2= LibStub("AceAddon-3.0"):NewAddon("TauntMaster2", "AceConsole-3.0", "AceEvent-3.0" );


local TauntMasterVariables = {
	positon = {
		top = 500,
		right = 500,
	},
	Spells = {
		DEATHKNIGHT ={
			--[[ Blood ]]
			[250] = {
				LeftButton				= 56222,--dark command
				LeftButtonMod			= "target",
				LeftButtonMacro			= false,
				AltLeftButton			= 6603,--Auto Attack
				AltLeftButtonMod			= "target",
				AltLeftButtonMacro		= false,
				ShiftLeftButton			= 6603,--Auto Attack
				ShiftLeftButtonMod		= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton 			= 6603,--Auto Attack
				CtrlLeftButtonMod		= "target",
				CtrlLeftButtonMacro		= false,

				RightButton				= 49576,--death grip
				AltRightButton			= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro		= false,
				ShiftRightButton			= 6603,--Auto Attack
				ShiftRightButtonMod		= "target",
				ShiftRightButtonMacro	= false,
				CtrlRightButton 			= 6603,--Auto Attack
				CtrlRightButtonMod		= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Frost ]]
			[251] = {
				LeftButton				= 49143, -- froststrike
				LeftButtonMod			= "target",
				LeftButtonMacro			= false,
				AltLeftButton			= 6603,--Auto Attack
				AltLeftButtonMod			= "target",
				AltLeftButtonMacro		= false,
				ShiftLeftButton			= 6603,--Auto Attack
				ShiftLeftButtonMod		= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton 			= 6603,--Auto Attack
				CtrlLeftButtonMod		= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton 				= 49576,--death grip
				AltRightButton			= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro		= false,
				ShiftRightButton			= 6603,--Auto Attack
				ShiftRightButtonMod		= "target",
				ShiftRightButtonMacro	= false,
				CtrlRightButton 			= 6603,--Auto Attack
				CtrlRightButtonMod		= "target",
				CtrlRightButtonMacro		= false,
			},
 			--[[ Unholy ]]
			[252] = {
				LeftButton 				= 49206, -- summon-gargoyle
				LeftButtonMod			= "target",
				LeftButtonMacro			= false,
				AltLeftButton			= 6603,--Auto Attack
				AltLeftButtonMod			= "target",
				AltLeftButtonMacro		= false,
				ShiftLeftButton			= 6603,--Auto Attack
				ShiftLeftButtonMod		= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton 			= 6603,--Auto Attack
				CtrlLeftButtonMod		= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton 				= 49576,--death gripk
				AltRightButton			= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro		= false,
				ShiftRightButton			= 6603,--Auto Attack
				ShiftRightButtonMod		= "target",
				ShiftRightButtonMacro	= false,
				CtrlRightButton 			= 6603,--Auto Attack
				CtrlRightButtonMod		= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		DRUID = { 
			--[[ Balance ]]
			[102] = {
				LeftButton 				= 6603,--Auto Attack
				LeftButtonMod			= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Feral Combat ]] 
			[103] = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Guardian ]]
			[104]  = {
				LeftButton = 6795,--Growl
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton = 22812,--Barkskin
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Restoration ]]
			[105] = {
				LeftButton				= 774, -- Rejuvenation
				LeftButtonMod			= "target",
				LeftButtonMacro			= false,
				AltLeftButton			= 6603, --Auto Attack
				AltLeftButtonMod			= "target",
				AltLeftButtonMacro		= false,
				ShiftLeftButton			= 6603,--Auto Attack
				ShiftLeftButtonMod		= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton			= 6603,--Auto Attack
				CtrlLeftButtonMod		= "target",
				CtrlLeftButtonMacro		= false,

				RightButton				= 8936, -- Regrowth
				AltRightButton			= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro		= false,
				ShiftRightButton			= 6603,--Auto Attack
				ShiftRightButtonMod		= "target",
				ShiftRightButtonMacro	= false,
				CtrlRightButton			= 6603,--Auto Attack
				CtrlRightButtonMod		= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		HUNTER ={
			--[[ Beast Mastery ]]
			[253]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Marksmanship ]]
			[254]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Survival ]]
			[255]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		MAGE ={
			--[[ Arcane ]]
			[62]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Fire ]]
			[63]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Frost ]]
			[64]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		MONK ={
			--[[ Brewmaster ]]
			[268]  = {
				LeftButton = 115546,--Provoke
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Windwalker  ]]
			[269]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Mistweaver  ]]
			[270]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		PALIDIN ={
			--[[ Holy ]]
			[65]  = {
				LeftButton = 25914, -- holy-shock
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton = 19750, --flash-of-light
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Protection ]]
			[66]  = {
				LeftButton = 62124,--Hand of reckoning
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton = 1022,--Hand of Protection
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Retribution ]]
			[70]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		PRIEST ={
			--[[ Discipline ]]
			[256]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Holy ]]
			[257]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Shadow ]]
			[258]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		ROGUE ={
			--[[ Assassination ]]
			[259]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Combat ]]
			[254]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Subtlety ]]
			[261]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		SHAMAN ={
			--[[ Elemental ]]
			[262]  = {
				LeftButton = 175621, -- lavaburst
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton = 117014, --elemental-blast
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Enhancement ]]
			[263]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Restoration ]]
			[264]  = {
				LeftButton = 61295, -- riptide
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton = 73920, -- healing-rain
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		WARLOCK ={
			--[[ Affliction ]]
			[265]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Demonology ]]
			[266]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Destruction ]]
			[267]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
		WARRIOR ={
			--[[ Arms ]]
			[71]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Fury ]]
			[72]  = {
				LeftButton = 6603,--Auto Attack
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton = 6603,--Auto Attack
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
			--[[ Protection ]]
			[73]  = {
				LeftButton = 355,--Taunt
				LeftButtonMod		= "target",
				LeftButtonMacro		= false,
				AltLeftButton		= 6603,--Auto Attack
				AltLeftButtonMod		= "target",
				AltLeftButtonMacro	= false,
				ShiftLeftButton		= 6603,--Auto Attack
				ShiftLeftButtonMod	= "target",
				ShiftLeftButtonMacro		= false,
				CtrlLeftButton = 6603,--Auto Attack
				CtrlLeftButtonMod	= "target",
				CtrlLeftButtonMacro		= false,
				
				RightButton = 3411,--Intervene
				AltRightButton		= 6603,--Auto Attack
				AltRightButtonMod		= "target",
				AltRightButtonMacro	= false,
				ShiftRightButton		= 6603,--Auto Attack
				ShiftRightButtonMod	= "target",
				ShiftRightButtonMacro		= false,
				CtrlRightButton = 6603,--Auto Attack
				CtrlRightButtonMod	= "target",
				CtrlRightButtonMacro		= false,
			},
		},
	}
}

function TauntMaster2:OnInitialize()
	-- Called when the addon is loaded

	self.db = LibStub("AceDB-3.0"):New("TM2DB30006");
	

end

function TauntMaster2:OnEnable()
	self:Print("Alpha Preview Version: " ..GetAddOnMetadata("TauntMaster2", "Version") )
	TauntMaster2:LoadVariables()
tm2DrawConfig()


	TauntMasterGUI_ShowFrame()
	--if(TauntMasterUnitFrames_Header:GetAttribute'showParty') then
	--HidePartyFrame() 
	--end
	--TauntMasterGUI_resolve_frame()
end

function TauntMaster2:OnDisable()
	-- Called when the addon is disabled
end

function TauntMaster2:LoadVariables()

	local currentSpec = GetSpecialization()
	local currentSpecName = currentSpec and select(1, GetSpecializationInfo(currentSpec)) or "None"
	

	TauntMaster2.db.char.Spellbook = TauntMaster2.db.char.Spellbook or {}
	local tm2numTabs = GetNumSpellTabs()
	for BookTabs = 1,tm2numTabs do
		local name,texture,offset,numSpells = GetSpellTabInfo(BookTabs)
		--print("Spell tab \"" .. name .. "\" contains spells from id " .. offset + 1 .. " through " .. offset + numSpells)
		for BookSpells = offset + 1,offset + numSpells do
			TauntMaster2.db.char.Spellbook[name] = TauntMaster2.db.char.Spellbook[name] or {}

			local skillName = GetSpellBookItemName(BookSpells, "spell")
			local tmpspellid = select(7,GetSpellInfo(skillName))
			if BookTabs <=5 then
				if (IsAttackSpell(BookSpells, "spell"))  then
					--print(tmpspellid , skillName )
				end
			end
			if ((IsHarmfulSpell(BookSpells, "spell") or IsHelpfulSpell(BookSpells, "spell")) and not (IsPassiveSpell(BookSpells, "spell"))) or (IsAttackSpell(BookSpells, "spell"))  then 
				TauntMaster2.db.char.Spellbook[name][skillName] = tmpspellid
			end
		end
	end
	
	TauntMaster2.db.char.class	= TauntMaster2.db.char.class or select(2, UnitClass("player")) or "WARRIOR"
	TauntMaster2.db.char.id		= currentSpecName
	--GUI

	--TauntMaster2.db.char.gui	= TauntMaster2.db.char.gui or TauntMasterVariables.GUI
	TauntMaster2.db.char.gui 				= TauntMaster2.db.char.gui or {}
	TauntMaster2.db.char.gui.maxColumns		= TauntMaster2.db.char.gui.maxColumns or 8
	TauntMaster2.db.char.gui.unitsPerColumn	= TauntMaster2.db.char.gui.unitsPerColumn or 5
	TauntMaster2.db.char.gui.width			= TauntMaster2.db.char.gui.width or 63
	TauntMaster2.db.char.gui.height			= TauntMaster2.db.char.gui.height or 32
	TauntMaster2.db.char.gui.scale			= TauntMaster2.db.char.gui.scale or 1
	TauntMaster2.db.char.gui.positon		= TauntMaster2.db.char.gui.position or {}
	--Spells
	TauntMaster2.db.char.Spells	= TauntMaster2.db.char.Spells or TauntMasterVariables.Spells[TauntMaster2.db.char.class]
	--TauntMaster2.db.char.spells	= TauntMaster2.db.char.spells.LeftButton or TauntMasterVariables.Spells [TauntMaster2.db.char.class]
end

----------------------------------------------------------------------------
-- Minimap Button functions
----------------------------------------------------------------------------

local TM2MinimapBtn = CreateFrame("BUTTON", "tm2Minimap",Minimap)
	TM2MinimapBtn:SetWidth(33)
	TM2MinimapBtn:SetHeight(33)
	TM2MinimapBtn:SetClampedToScreen(true)
	TM2MinimapBtn:SetPoint("TOPLEFT")
	local overlay = TM2MinimapBtn:CreateTexture(nil, "OVERLAY")
		overlay:SetSize(53, 53)
		overlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
		overlay:SetPoint("TOPLEFT")
	local background = TM2MinimapBtn:CreateTexture(nil, "BACKGROUND")
		background:SetSize(20, 20)
		background:SetTexture("Interface\\Minimap\\UI-Minimap-Background")
		background:SetPoint("TOPLEFT", 7, -5)	
	local icon = TM2MinimapBtn:CreateTexture(nil, "ARTWORK")
		icon:SetSize(17, 17)
		icon:SetTexture("Interface\\AddOns\\TauntMaster2\\Icons\\tmicon")
		icon:SetPoint("TOPLEFT", 7, -6)
	TM2MinimapBtn:SetMovable(true)
	TM2MinimapBtn:EnableMouse(true)
	TM2MinimapBtn:RegisterForDrag("")
	TM2MinimapBtn:RegisterForClicks("AnyUp")
	TM2MinimapBtn:SetScript("OnDragStart", TM2MinimapBtn.StartMoving)
	TM2MinimapBtn:SetScript("OnDragStop", TM2MinimapBtn.StopMovingOrSizing)
	TM2MinimapBtn:SetScript("OnClick", function(self, button2) 
		if (button2 =="" ) then

			if (TauntMasterUnitFrames_Header:IsVisible()) then
				TauntMasterUnitFrames_Header:Hide()
			else
				TauntMasterUnitFrames_Header:Show()
			end
			
		elseif (button2 =="RightButton" ) then
			TauntMasterUnitFrames_Header:SetAttribute("maxColumns", 0)
			TauntMasterUnitFrames_Header:Hide()
			TauntMasterUnitFrames_Header:SetAttribute("maxColumns", 8)
			TauntMasterUnitFrames_Header:Show()
		end
	end)
TM2MinimapBtn:SetScript("OnDragStart", TM2MinimapBtn.StartMoving)
	
	TM2MinimapBtn:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		GameTooltip:AddLine("Taunt Master 2",1,1,1)
		GameTooltip:AddLine(" ")
		--GameTooltip:AddDoubleLine(L["Left Click"], L["Toggle Minitax Frame"], 0,1,0, 1,1,1);
		--GameTooltip:AddDoubleLine(L["Right Click"], L["Opens Interface Options"], 0,1,0, 1,1,1);
		GameTooltip:Show()
    end)
     
    TM2MinimapBtn:SetScript("OnLeave", function() GameTooltip:Hide() end)
	
	TM2MinimapBtn:SetAlpha(1)
	TM2MinimapBtn:Show()

function TM2MinimapBtn_Hide()
	TM2MinimapBtn:Hide()
end

function TM2MinimapBtn_show()
	TM2MinimapBtn:Show()
end


